/*
 * MosP - Mind Open Source Project    http://www.mosp.jp/
 * Copyright (C) MIND Co., Ltd.       http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.kintai.action;

import java.util.Date;

import jp.mosp.common.CommonConst;
import jp.mosp.common.common.BaseVo;
import jp.mosp.common.common.MospConst;
import jp.mosp.common.common.MospException;
import jp.mosp.common.utils.DateUtil;
import jp.mosp.common.utils.VariousUtil;
import jp.mosp.kintai.common.action.MosPWorkflowAction;
import jp.mosp.kintai.common.part.KintaiApprovalPart;
import jp.mosp.kintai.common.part.KintaiCommonPart;
import jp.mosp.kintai.dto.MScheduleDto;
import jp.mosp.kintai.dto.MSyukkinboDto;
import jp.mosp.kintai.vo.AttendanceStartCardVo;

/**
 * @author yoshida
 *
 */
public class AttendanceStartCardAction extends MosPWorkflowAction {
	
	// コマンド
	/**
	 * K1100
	 */
	public static final String	CMD_START_CARD_SHOW			= "K1100";
	private static final String	CMD_START_CARD_REGIST		= "K1102";
	private static final String	CMD_START_CARD_DELETE		= "K1103";
	private static final String	CMD_START_CARD_DRAFT		= "K1104";
	private static final String	CMD_START_CARD_REFLECT		= "K1105";
	private static final String	CMD_START_CARD_CALCULATE	= "K1106";
	

	/**
	 * コンストラクタ
	 */
	public AttendanceStartCardAction() {
		super();
	}
	
	/**
	 * アクション
	 */
	public void action() throws Exception {
		// VOの取得
		prepareVo();
		// 初期処理
		init();
		// コマンド毎の処理
		if (cmd.equals(CMD_START_CARD_SHOW)) {
			// 表示
			show();
		} else if (cmd.equals(CMD_START_CARD_REGIST)) {
			// 登録
			regist(false);
		} else if (cmd.equals(CMD_START_CARD_DELETE)) {
			// 削除
			delete();
		} else if (CMD_START_CARD_DRAFT.equals(cmd)) {
			// 下書き
			regist(true);
		} else if (CMD_START_CARD_REFLECT.equals(cmd)) {
			// 予定の反映
			reflect();
		} else if (CMD_START_CARD_CALCULATE.equals(cmd)) {
			// 集計
			runCalc();
		} else {
			throw new MospException(MospConst.EX_CMD_INVALID);
		}
	}
	
	@Override
	protected BaseVo getSpecificVo() {
		return new AttendanceStartCardVo();
	}
	
	@Override
	protected void init() throws Exception {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		// ユーザー情報取得
		getInfo(user.getUserId());
		// 勤務形態プルダウン
		vo.aryPltWorkType = part().worktype().getWorkTypeInfoArrayWithHoliday();
		// 出勤時半休区分プルダウン
		vo.aryPltHalfHoliday = getHalfHolidayArray();
		// 休出区分プルダウン
		vo.aryPltWorkOnHoliday = getMosPCodeArray(CommonConst.TID_WORK_ON_HOLIDAY_TYPE);
		// 遅刻理由プルダウン
		vo.aryPltLateReason = getReasonCodeArray(CommonConst.TID_LATE_REASON);
		// 遅刻証明書プルダウン
		vo.aryPltLateCertificate = getMosPCodeArray(CommonConst.TID_LATE_CERTIFICATE);
		// 勤怠管理コマンド
		setSubTitleMenu();
	}
	
	@Override
	protected void show() throws Exception {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		// 表示項目の初期化
		vo.initFields();
		// 表示、登録の準備
		setAttendanceInfo();
		// 残業申請情報設定
		setOverTimeRequestInfo();
		// 勤怠検索
		MSyukkinboDto dto = kintai().getSyukkinboInfo(vo.getHidKCode(), vo.getHidDate(), false);
		if (VariousUtil.isNotNull(dto)) {
			// VOに情報を設定
			vo.setFields(dto);
			if (!KintaiApprovalPart.isDraft(dto)) {
				vo.setDraft(false);
			}
		}
		// 表示モードのセット
		setMode(dto);
	}
	
	/**
	 * 出勤登録
	 * @param isDraft		下書きフラグ
	 * @throws Exception	例外処理が発生した場合
	 */
	private void regist(boolean isDraft) throws Exception {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		vo.setParams(request);
		String kCode = vo.getHidKCode();
		Date targetDate = DateUtil.convStringDateToDate(vo.getHidDate());
		// 勤怠検索
		MSyukkinboDto dto = kintai().getSyukkinboInfo(kCode, targetDate, true);
		if (VariousUtil.isNull(dto)) {
			// 新規登録
			dto = new MSyukkinboDto();
			// 週休の場合
			if (KintaiCommonPart.isWeekHoliday(vo.getPltWorkType())) {
				setWeekHolidayDtoFields(dto);
			} else if (KintaiCommonPart.isOfficialHoliday(vo.getPltWorkType())) {
				// 法定休日
				setOfficialHolidayDtoFields(dto);
			} else {
				vo.setDtoFields(dto);
			}
			dto.setSyozoku(getBelongSectionCode(kCode));
			// 下書き判断
			if (isDraft) {
				dto.setSnRiyuu(CommonConst.CODE_DRAFT);
			}
			// 存在チェック
			chkDuplicate(kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), false));
			// 週休、法定休日の場合
			if (KintaiCommonPart.isWeekHoliday(dto) || KintaiCommonPart.isOfficialHoliday(dto)) {
				// 自動計算
				runAutoStartCalc(dto);
				// 登録
				syukkinboDao().insert(dto);
				// メッセージ設定
				setMessage(getMessage(MospConst.MSG_INSERT, ""));
			} else {
				boolean insertFlag = true;
				// 半休の場合、残日数をチェックする。
				if (KintaiCommonPart.isStartHalfHoliday(dto)) {
					if (!part().holidayRequest().isApprovedPaidHolidayRequestStartHalf(dto)) {
						insertFlag = checkRemainPaidHoliday(kCode, targetDate, CommonConst.NUM_HALF_DAY, 0);
					}
				}
				// 時間外代休(半日)の場合、残日数をチェックする。
				if (part().mospcode().useSubstituteHolidayFunction() && KintaiCommonPart.isOverTimeSubHolidayStart(dto)) {
					if (!part().holidayRequest().isApprovedSubstituteHolidayRequestStartHalf(dto)) {
						insertFlag = checkRemainSubstitute(kCode, targetDate, CommonConst.NUM_HALF_DAY);
					}
				}
				if (insertFlag) {
					// 自動計算
					runAutoStartCalc(dto);
					// 午前半休の承認がある場合、反映
					margeHolidayRequest(dto);
					// 登録（出勤項目のみ）
					syukkinboDao().insertStart(dto);
					// メッセージ設定
					setMessage(getMessage(MospConst.MSG_INSERT, ""));
				}
			}
		} else {
			// 承認済みの場合はメッセージ表示、登録不可
			if (KintaiApprovalPart.isApproved(dto)) {
				// メッセージ設定
				setMessage(getMessage(CommonConst.MSG_ALREADY_APPROVED, getMessageDate(dto)));
			} else {
				// 排他確認
				chkExclusive(dto, kintai().getSyukkinboInfo(dto.getKCode(), dto.getHizuke(), true));
				// UPDATE
				vo.setDtoFields(dto);
				// 下書き判断
				if (isDraft) {
					dto.setSnRiyuu(CommonConst.CODE_DRAFT);
				}
				boolean updateFlag = true;
				// 半休の場合、残日数をチェックする。
				if (KintaiCommonPart.isStartHalfHoliday(dto)) {
					if (!part().holidayRequest().isApprovedPaidHolidayRequestStartHalf(dto)) {
						updateFlag = checkRemainPaidHoliday(kCode, targetDate, CommonConst.NUM_HALF_DAY, 0);
					}
				}
				// 時間外代休(半日)の場合、残日数をチェックする。
				if (part().mospcode().useSubstituteHolidayFunction() && KintaiCommonPart.isOverTimeSubHolidayStart(dto)) {
					if (!part().holidayRequest().isApprovedSubstituteHolidayRequestStartHalf(dto)) {
						updateFlag = checkRemainSubstitute(kCode, targetDate, CommonConst.NUM_HALF_DAY);
					}
				}
				if (updateFlag) {
					// 自動計算
					runAutoStartCalc(dto);
					// 午前半休、時間単位の年休の承認がある場合、反映
					margeHolidayRequest(dto);
					// 更新（出勤項目のみ）
					syukkinboDao().updateStart(dto);
					// メッセージ設定
					setMessage(getMessage(MospConst.MSG_UPDATE, ""));
				}
			}
		}
		// コミット
		commit();
		// 勤怠一覧へ遷移
		setNextCmd(AttendanceListAction.CMD_ATTENDANCE_LIST_RE_SEARCH);
	}
	
	/**
	 * 予定の反映
	 * @throws Exception	例外処理が発生した場合
	 */
	private void reflect() throws Exception {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		String kCode = vo.getHidKCode();
		String strTargetDate = vo.getHidDate();
		MScheduleDto dto = kintai().getScheduleInfo(kCode, strTargetDate);
		if (VariousUtil.isNull(dto)) {
			dto = kintai().createScheduleInfo(part().human().getBasisInfo(kCode),
					DateUtil.convStringDateToDate(strTargetDate), vo.getPltWorkType());
		}
		if (KintaiCommonPart.isAvailableWorkType(dto)) {
			// 休暇申請とマージ
			margeHolidayRequest(dto);
		}
		// VOに情報を設定
		vo.setFields(KintaiCommonPart.copyToSyukkinbo(dto));
	}
	
	/**
	 * 集計
	 * @throws Exception	例外処理が発生した場合
	 */
	private void runCalc() throws Exception {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		vo.setParams(request);
		// パラメータの妥当性確認
		vo.validate();
		MSyukkinboDto dto = new MSyukkinboDto();
		vo.setDtoFields(dto);
		// 勤怠情報設定
		setCalcParam();
		if (KintaiCommonPart.isWeekHoliday(dto)) {
			vo.initFields();
			// 週休の場合
			dto.setKinmu(CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY);
		} else if (KintaiCommonPart.isOfficialHoliday(dto)) {
			vo.initFields();
			// 法定休日
			dto.setKinmu(CommonConst.ATTENDANCE_TYPE_OFFICIAL_HOLIDAY);
		} else {
			kintai().runStartCalculate(dto);
		}
		// VOに情報を設定
		vo.setFields(dto);
	}
	
	/**
	 * 自動計算メソッド
	 * @param dto	対象DTO
	 * @throws Exception	例外処理が発生した場合
	 */
	private void runAutoStartCalc(MSyukkinboDto dto) throws Exception {
		// 勤怠情報設定
		setCalcParam();
		// 自動計算フラグ有り且つ週休以外のみ、勤務形態から遅刻時間を計算
		// 日次自動計算フラグ
		if (isDailyAutoCalc && KintaiCommonPart.isAvailableWorkType(dto)) {
			// 出勤項目の計算
			kintai().runStartCalculate(dto);
		}
	}
	
	/**
	 * フィールド設定（週休用）
	 * @param dto	対象DTO
	 */
	private void setWeekHolidayDtoFields(MSyukkinboDto dto) {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		dto.setKCode(vo.getHidKCode());
		dto.setHizuke(DateUtil.convStringDateFormatted(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay()));
		dto.setNen(Integer.parseInt(vo.getHidYear()));
		dto.setTuki(Integer.parseInt(vo.getHidMonth()));
		dto.setHi(Integer.parseInt(vo.getHidDay()));
		dto.setKinmu(CommonConst.ATTENDANCE_TYPE_WEEK_HOLIDAY);
		dto.setSyJikoku("");
		dto.setTaJikoku("");
		dto.setSnRiyuu(CommonConst.NUM_ATTENDANCE_REQUEST);
		dto.setUpdtTimes(DateUtil.getDateTime(DateUtil.getNowDate()));
	}
	
	/**
	 * フィールド設定（法定休日用）
	 * @param dto	対象DTO
	 */
	private void setOfficialHolidayDtoFields(MSyukkinboDto dto) {
		AttendanceStartCardVo vo = (AttendanceStartCardVo)getVo();
		dto.setKCode(vo.getHidKCode());
		dto.setHizuke(DateUtil.convStringDateFormatted(vo.getHidYear(), vo.getHidMonth(), vo.getHidDay()));
		dto.setNen(Integer.parseInt(vo.getHidYear()));
		dto.setTuki(Integer.parseInt(vo.getHidMonth()));
		dto.setHi(Integer.parseInt(vo.getHidDay()));
		dto.setKinmu(CommonConst.ATTENDANCE_TYPE_OFFICIAL_HOLIDAY);
		dto.setSyJikoku("");
		dto.setTaJikoku("");
		dto.setSnRiyuu(CommonConst.NUM_ATTENDANCE_REQUEST);
		dto.setUpdtTimes(DateUtil.getDateTime(DateUtil.getNowDate()));
	}
	
}
